// I may fail a thousand times
// But there is no giving up
// IOI - here I come
#include <iostream>
#include <algorithm>
#include <cstring>
using namespace std;
int cnt[(int)2e5+5][26];
int rem[26];
signed main(){
  ios_base::sync_with_stdio(0);cin.tie(0);
	string s;cin>>s;
	int n=s.length();
	for(int i=1;i<=n;i++){
		for(int j=0;j<26;j++)cnt[i][j]=cnt[i-1][j];
		cnt[i][s[i-1]-'a']++;
	}
	int j=0;
	for(int i=1;i<=n/2;i++){
		if(j==i-1){
			if(s[i-1]==s[n-i])j++;
		}else break;
	}
	int k=n/2+1;
	for(int i=n/2;i>=1;i--){
		if(k==i+1){
			if(s[i-1]==s[n-i])k--;
		}else break;
	}
	int flag=1;
	k--;
	int ans=n;
	for(int i=0;i<26;i++){
		if(cnt[k][i]-cnt[j][i]!=cnt[n-j][i]-cnt[n-k][i])flag=0;
	}	
	if(flag)ans=min(ans,max(0,k-j));
	for(int i=n/2+1;i<=n-j;i++){
		int flag=1;
		for(int l=0;l<26;l++){
			rem[l]=cnt[i][l]-cnt[j][l];
			rem[l]-=cnt[n-j][l]-cnt[i][l];
			if(rem[l]<0)flag=0;
		}
		int p=0;
		for(int l=0;l<26;l++){
			if(rem[l]&1)p++;
		}
		if(p>1)flag=0;
		if(flag)ans=min(ans,i-j);
	}
	for(int i=n/2+(n&1);i>j;i--){
		int flag=1;
		for(int l=0;l<26;l++){
			rem[l]=cnt[n-j][l]-cnt[i-1][l];
			rem[l]-=cnt[i-1][l]-cnt[j][l];
			if(rem[l]<0)flag=0;
		}
		int p=0;
		for(int l=0;l<26;l++){
			if(rem[l]&1)p++;
		}
		if(p>1)flag=0;
		if(flag)ans=min(ans,n-j+1-i);
	}
	cout<<max(1,ans)<<'\n';
  return 0;
}